#include "st.h"
#include "zlibengn.h"

//
// main
//

void print_vec_char (char_vector& x) {
  //
  // print a vector<char> in chars
  //
  for (char_vector_iterator i = x.begin(); i != x.end(); ++i)
    cout << *i;
  // end print_vec_char
}

char_vector vec(char *s) {
  char_vector x;
  while (*s != '\0') 
    x.push_back(*s++);
  return x;
}

int main() {
    ZlibEngine engine;

    //engine.compress("mao", "mao.gz", Z_DEFAULT_COMPRESSION, Z_HUFFMAN_ONLY);
    //engine.decompress("mao.gz", "mao.orig");
    char_vector b = vec("maramaomamamamammammaammmmmmmmmmmmmmmaaa");
    print_vec_char(b);
    cout << endl;
    char_vector a = engine.huffman_encoder(b);
    cout << b.size() << " " << a.size() << endl;
    char_vector c = engine.huffman_decoder(a);
    print_vec_char(c);
    cout << endl;
}
